require "./truncate_html_helper"

describe TruncateHtmlHelper do
  include TruncateHtmlHelper

  specify "basic truncation inside block-level element" do
    truncate_html("<p>A <strong>thing</strong> which gets truncated.</p><p>With trailing elements</p>", length: 8).should == "<p>A <strong>thing</strong>…</p>"
  end

  specify "empty elements are preserved, but danglers are removed" do
    truncate_html("<p>And<br>line<br>breaks<br>are<br>preserved.</p>", length: 8).should == "<p>And<br>line…</p>"
  end

  specify "omissions are outside inline elements" do
    truncate_html("<strong>Thing</strong> and <em>stuff</em>", length: 6).should == "<strong>Thing</strong>…"
  end

  specify "default length is 30" do
    truncate_html("a" * 50).should == "a" * 29 << "…"
  end

  specify "alternate omission text" do
    truncate_html("<div>a<em>b</em>cdef</div>", length: 6, omission: "...").should == "<div>a<em>b</em>c...</div>"
  end
end
